-- Use the correct database
USE dbccpagetest;
GO

-- Drop the table
DROP TABLE rowoverflowtest;
GO

-- Create a table with a schema that can cause off-row columns
CREATE TABLE rowoverflowtest (
	c1	INT,
	c2	VARCHAR (8000),
	c3	VARCHAR	(8000));
GO
CREATE CLUSTERED INDEX row_cl 
ON rowoverflowtest (c1);
GO

-- Insert some rows
INSERT INTO rowoverflowtest VALUES (1, REPLICATE ('a', 100), REPLICATE ('b', 100));
INSERT INTO rowoverflowtest VALUES (2, REPLICATE ('a', 100), REPLICATE ('b', 100));
INSERT INTO rowoverflowtest VALUES (3, REPLICATE ('a', 100), REPLICATE ('b', 100));
INSERT INTO rowoverflowtest VALUES (4, REPLICATE ('a', 100), REPLICATE ('b', 100));
INSERT INTO rowoverflowtest VALUES (5, REPLICATE ('a', 100), REPLICATE ('b', 100));
GO

DBCC IND ('dbccpagetest', 'rowoverflowtest', 1)
go

-- Examine the page - everything's in-row
DBCC TRACEON (3604);
GO
DBCC PAGE (dbccpagetest, 1, 154, 3);
GO

-- Now let's cause an off-row column
UPDATE rowoverflowtest SET 
	c3 = REPLICATE ('c', 8000) -- 8104 bytes of data
WHERE c1 = 3;
GO

-- And when we look at the page, we can see the off-row link
DBCC PAGE (dbccpagetest, 1, 154, 3);
GO

-- Follow the off-row link
DBCC PAGE (dbccpagetest, 1, 156, 3);
GO
